<template>
	<mind-layout-table :data="ListaClientes" rowKey="id" 
		:path="$route.path" @delete="onDelete" @filter="filtrar"
		>
			<template v-slot:filter="{form}">
				<el-row  >
					<el-col  :lg="12">
						<el-form-item label="Nombre">
							<el-input v-model="form.nombre"  />
						</el-form-item>
					</el-col>
					<el-col  :lg="12">
						<el-form-item label="Direccion">
							<el-input v-model="form.calle"  />
						</el-form-item>
					</el-col>
					<el-col  :lg="12">
						<el-form-item label="Teléfono">
							<el-input v-model="form.telefono"  />
						</el-form-item>
					</el-col>
				</el-row>
			</template>
			<el-table-column sortable prop="id" label="Cliente" width="100" />
			<el-table-column sortable prop="nombre" label="Nombre"  />
			<el-table-column sortable :sort-method="ordenarCalle" prop="domicilio" label="Domicilio"  />
			<el-table-column prop="telefono" label="Telefono" width="150" />
			<el-table-column prop="movil" label="Móvil" width="150" />
	</mind-layout-table>
</template>

<script>
import store from '@/store/clientes'
import {Rest} from '@/../vendor/mind-core-web'

export default {
  async created() {
		store.idAgencia = 1

		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/clientes`, 
			state: store.data,
			key: 'id'})

		this.api.FetchAll().catch((error)=>{
			this.$message({
				showClose: true,
				type: 'error',
				message: error
			});
		})
	},
	computed:{
		/**
		 * Devuelve la lista de Clientes
		 */
		ListaClientes() {
			let lista = []
			if(!store.data.RESOURCE_LIST) {
				return []
			}
			for(const r of store.data.RESOURCE_LIST) {
				lista.push({
					...r, 
					domicilio: `${r.calle} ${r.numero}`})
			}
			return lista
		},
	},
	methods: {
		/**
		 * Elimina el recuros especificado
		 * @param id recurso del elemento a eliminar
		 */
		onDelete(id){
			this.api.Delete(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		/**
		 * regla para ordernar la columna de clientes
		 */
		ordenarCalle(a, b){
			const calleA = a.calle.trim()
			const calleB = b.calle.trim()
			return calleA < calleB ? -1 : calleA > calleB ? 1 : a.numero < b.numero ? -1 : 1
		},
		filtrar(filtros) {
			this.api.FetchAll({
				filters: filtros
			})
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})

			// console.log('filtrar', filtros)
		}
	},
	data() {
		return {
			api: null,
			filtroActivo: false,
		}
	}
	
}
</script>
